1



Chapter 1.  C Preliminaries

A Brief Review of C

Form of a C Program

(<#include statements>)    //    (<stdio.h> and <math.h> are necessary here)
{<global variable declaration section>}
function A;
function B; begin
     {<local variable declaration section>}
     {<executable-statements>}
     A;
     {<executable-statements>}
     B;
               {<executable-statements>}
     end.


Form of a C function

     <result-type> <function-name> [(<formal-parameter-list>)];
         {
              {<local declaration section>}
              {<executable-statements>} i.e. function body
              return (<return-value>);
         }


Form of a C Procedure or Subroutine (Function which returns no value)

     void <procedure-name>[(<formal-parameter-list>)]
         {
              {<local declaration section>}
              {<executable-statements>} i.e. procedure body
         }


Form of a Call to a Procedure.

     <procedure-name>[<actual-parameter-list>]


Very important note

     C is a pass-by value language.
In order to change the contents of a variable, three changes must be made to the notes above:
          1)     in the <actual-parameter-list>, the variable must be preceded by a &:
                   ProcedureA (&x, y, z)
          2)     in the <formal-parameter-list>, a * must be inserted between the
                  type and the variable name:
                   void ProcedureA (int *x, int y, int z);
          3)     in the <executable-statements> of the function, a * must precede
                  the variable name:
                    ...
                    *x = *x - y * z


Definition of Constants

          #define Max     10;
          #define Pi      3.1415926535;
          #define Small   1e-20;


Specification Statements (Declaration Part)

          typedef float VECTOR[5];
          typedef float MATRIX[5][5];
          typedef int POINTER[Subs];
          typedef enum (Done,Iterating,Working) STATUS;
          typedef char WORDS[80];

          int Column,I,J;
          float A0,B0,Max,X,Y;
          Flag: boolean;
          V,R: VECTOR;
          A,D: MATRIX;
          Row: POINTER;
          Name: string[80];
          Lines: WORDS;
          State: STATUS;


Note about arrays

     Array subscripting begins at 0 in C, and ends at N-1 for an array of N elements
     example:

      int myArray[20] has 20 elements;
          myArray[0] accesses the first, and myArray[19] accesses the last.


Assignment Statements

     X = A[1] + 3;
     Y = A*X*X + B*X + C;
     Flag = TRUE;
     Name = "Fran";


Arithmetic Operations

     +     Addition
     -     Subtraction
     *     Multiplication
     /     Division
     /     Integer Division
     %     Remainder (Integer)


Relational Operators

     ==     Equal to
     !=     Not equal to
     <      Less than
     >      Greater than
     <=     Less than or equal to
     >=     Greater than or equal to


Logical Operators

     !      Complement
     &&     True if both operands are true
     ||     True if either (or both) operands are true


Comments

     //     This is a single-line comment.
     /*     This is a 
            mulit-line 
            comment.*/


Unconditional Transfer

     goto 100;
     ...
     100:

     Warning. A GOTO statement must not leave the current block.


IF (Block) Control Statement

Performs the series of {<executable-statement>} following it or transfers control to an else, or end statement, depending on the value of the (<logical-expression>).

     if (<logical-expression>)
               {<one executable-statements>};


     if (<logical-expression>)
          {
               {<one executable-statement>};
          }


     if (<logical-expression>)
               {<one executable-statement>};
     else
               {<one executable-statement>};


     if (<logical-expression>)
          {
               {<executable-statements>};
          }
     else
          {
               {<executable-statements>};
          }


     if (<logical-expression-#1>)
          {
               {<executable-statements>}
          }
     else 
          {
               if (<logical-expression-#2>)
                    {
                         {<executable-statements>}
                    }
               else
                    {
                         {<executable-statements>}
                    }
          }


Indexed Loop Control Statement (for loop)

     for (<initialization> ; <test-condition> ; <incrementation>)
          <statement>

     for (<initialization> ; <test-condition> ; <incrementation>)
          {
               <statement>
               ...
               <statement>
          }

     <initialization>     initialize loop-control variable(s)
     <test-condition>     loop stops cycling when test becomes false
     <incrementation>     increments loop-control variable(s)


     Sum = 0;
     for (k = 0 ; k <= 100 ; k = k+1)
          Sum = Sum + k;

     Sum = 0;
     for (k = 1000 ; k >= 1 ; k = k-1)
          Sum := Sum + 1.0/k;

     for (j = 1 ; j <= 5 ; j = j+1)
          for (k = 1 ; k <= 5 ; k = k+1)
               A[j,k] = 1.0/(j+k-1);


While Loop Structure

     The <logical-expression> is evaluated first.  If the logical expression is true, then the loop body will be executed.  The sequence is repeated as long as the expression remains true.  If the expression is false, then the loop body will be skipped, and execution will continue with the statement following the }.

     while  (<logical-expression>)
          {
               {<executable-statements>};
          }


The following reserved words may be used in loops

     break;        exits innermost loop
     continue;     jumps to end of loop, then begins next loop cycle


Switch Statement

     Switch (FunType)
          {
               case 1:
                    F = x;
                    break;
               case 2:
                    F = x*x;
                    break;
               default:
                    F = x*x*x;
          }


Input and Output

     scanf:     (%i to read int, %f to read float, %lf to read double)
                (Variable name must be preceded by ampersand '&')

     scanf ("%i %f", &x, &y);

     scanf ("%lf", &A[i,j]);


     printf:     (%i to print int, %f to print float or double)
                 (a.b between % and flag indicate:
                    a:     Minimum field width
                    b:     Precision of number)

     printf ("\n");          //     Prints a blank line

     printf ("x = %i     y = %5.4f\n", x, y);

     printf ("A(i,j) = %15.5f", A[i,j]);


Mathematical Functions

     Functions returning type double:
          cos(x)      cosine (radians)
          sin(x)      sine (radians)
          exp(x)      exponential  exp(x)
          arctan(x)   inverse tangent (radians)
          ln(x)       natural logarithm base  e
          sqrt(x)     square root
          fabs(x)     absolute value (x is of type double)

     Functions returning type int:
          abs(x)      absolute value (x is of type int)

